<?php

//General

if(!function_exists('kudos_qodef_map_general')) {
    function kudos_qodef_map_general() {

        $general_meta_box = kudos_qodef_add_meta_box(
            array(
                'scope' => array('page', 'portfolio-item', 'post'),
                'title' => esc_html__('General', 'kudos'),
                'name' => 'general_meta'
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_boxed_meta',
                'type' => 'select',
                'label' => esc_html__('Boxed Layout', 'kudos'),
                'description' => esc_html__('Enabling this option will show boxed layout', 'kudos'),
                'parent' => $general_meta_box,
                'options' => array(
                    '' => '',
                    'yes' => esc_html__('Yes', 'kudos'),
                    'no' => esc_html__('No', 'kudos')
                )
            )
        );


        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_page_background_color_meta',
                'type' => 'color',
                'default_value' => '',
                'label' => esc_html__('Page Background Color', 'kudos'),
                'description' => esc_html__('Choose background color for page content', 'kudos'),
                'parent' => $general_meta_box
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_page_padding_meta',
                'type' => 'text',
                'default_value' => '',
                'label' => esc_html__('Page Padding', 'kudos'),
                'description' => esc_html__('Insert padding in format 10px 10px 10px 10px', 'kudos'),
                'parent' => $general_meta_box
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_page_slider_meta',
                'type' => 'text',
                'default_value' => '',
                'label' => esc_html__('Slider Shortcode', 'kudos'),
                'description' => esc_html__('Paste your slider shortcode here', 'kudos'),
                'parent' => $general_meta_box
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_page_transition_type',
                'type' => 'selectblank',
                'label' => esc_html__('Page Transition', 'kudos'),
                'description' => esc_html__('Choose the type of transition to this page', 'kudos'),
                'parent' => $general_meta_box,
                'default_value' => '',
                'options' => array(
                    'no-animation' =>  esc_html__('No animation', 'kudos'),
                    'fade' =>  esc_html__('Fade', 'kudos')
                )
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_page_comments_meta',
                'type' => 'selectblank',
                'label' => esc_html__('Show Comments', 'kudos'),
                'description' => esc_html__('Enabling this option will show comments on your page', 'kudos'),
                'parent' => $general_meta_box,
                'options' => array(
                    'yes' => esc_html__('Yes', 'kudos'),
                    'no' => esc_html__('No', 'kudos')
                )
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_passepartout_meta',
                'type' => 'selectblank',
                'label' => esc_html__('Enable Passepartout', 'kudos'),
                'description' => esc_html__('Enabling this option will show passepartout around wrapper on your page', 'kudos'),
                'parent' => $general_meta_box,
                'options' => array(
                    'yes' => esc_html__('Yes', 'kudos'),
                    'no' => esc_html__('No', 'kudos')
                )
            )
        );
    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_general');

}