<?php
namespace KudosQodef\Modules\Shortcodes\AdvancedVerticalSliderItem;

use KudosQodef\Modules\Shortcodes\Lib\ShortcodeInterface;
/**
 * Class AdvancedVerticalSliderItem
 */
class AdvancedVerticalSliderItem implements ShortcodeInterface {

    /**
     * @var string
     */
    private $base;

    public function __construct() {
        $this->base = 'qodef_advanced_vertical_slider_item';

        add_action('vc_before_init', array($this, 'vcMap'));
    }

    /**
     * Returns base for shortcode
     * @return string
     */
    public function getBase() {
        return $this->base;
    }

    /**
     * Maps shortcode to Visual Composer. Hooked on vc_before_init
     *
     * @see qode_core_get_carousel_slider_array_vc()
     */
    public function vcMap() {
        vc_map( array(
            'name' => esc_html__('Select AVS Item', 'kudos'),
            'base' => $this->getBase(),
            'category' => 'by SELECT',
            'as_child' => array('only' => 'qodef_advanced_vertical_slider'),
            'as_parent' => array('only' => 'vc_single_image, qodef_button, qodef_icon, qodef_icon_list_item, qodef_icon_with_text, qodef_list_ordered, qodef_progress_bar, qodef_separator, qodef_unordered_list, qodef_video_button, vc_empty_space, vc_column_text, qodef_custom_font'),
            'content_element' => true,
            'icon' => 'icon-wpb-advanced-vertical-slider-item extended-custom-icon',
            'js_view' => 'VcColumnView',
            'params' => array(
                array(
                    'type'			=> 'attach_image',
                    'heading'		=> esc_html__('Mobile Slider Image', 'kudos'),
                    'param_name'	=> 'avs_mobile_image'
                ),
                array(
                    'type' => 'colorpicker',
                    'class' => '',
                    'heading' => esc_html__('Background Color', 'kudos'),
                    'param_name' => 'avs_background_color',
                    'value' => '',
                    'description' => ''
                ),
                array(
                    'type' => 'attach_image',
                    'class' => '',
                    'heading' => esc_html__('Background Image', 'kudos'),
                    'param_name' => 'avs_background_image',
                    'value' => '',
                    'description' => ''
                )
            )
        ) );
    }

    /**
     * Renders shortcodes HTML
     *
     * @param $atts array of shortcode params
     * @param $content string shortcode content
     * @return string
     */
    public function render($atts, $content = null) {
        $args = array(
            'avs_mobile_image' => '',
            'avs_background_color' => '',
            'avs_background_image' => ''
        );

        $params = shortcode_atts($args, $atts);
        extract($params);
        $params['content']= $content;

        $html = '';

        $html .= kudos_qodef_get_shortcode_module_template_part('templates/avs-item-template', 'advanced-vertical-slider', '', $params);

        return $html;
    }
}