<?php

if(!function_exists('kudos_qodef_tabs_map')) {
    function kudos_qodef_tabs_map() {
		
        $panel = kudos_qodef_add_admin_panel(array(
            'title' => esc_html__('Tabs', 'kudos'),
            'name'  => 'panel_tabs',
            'page'  => '_elements_page'
        ));

        //Typography options
        kudos_qodef_add_admin_section_title(array(
            'name' => 'typography_section_title',
            'title' => esc_html__('Tabs Navigation Typography', 'kudos'),
            'parent' => $panel
        ));

        $typography_group = kudos_qodef_add_admin_group(array(
            'name' => 'typography_group',
            'title' => esc_html__('Tabs Navigation Typography', 'kudos'),
			'description' => esc_html__('Setup typography for tabs navigation', 'kudos'),
            'parent' => $panel
        ));

        $typography_row = kudos_qodef_add_admin_row(array(
            'name' => 'typography_row',
            'next' => true,
            'parent' => $typography_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'fontsimple',
            'name'          => 'tabs_font_family',
            'default_value' => '',
            'label'         => esc_html__('Font Family', 'kudos'),
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'selectsimple',
            'name'          => 'tabs_text_transform',
            'default_value' => '',
            'label'         => esc_html__('Text Transform', 'kudos'),
            'options'       => kudos_qodef_get_text_transform_array()
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'selectsimple',
            'name'          => 'tabs_font_style',
            'default_value' => '',
            'label'         => esc_html__('Font Style', 'kudos'),
            'options'       => kudos_qodef_get_font_style_array()
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'textsimple',
            'name'          => 'tabs_letter_spacing',
            'default_value' => '',
            'label'         => esc_html__('Letter Spacing', 'kudos'),
            'args'          => array(
                'suffix' => 'px'
            )
        ));

        $typography_row2 = kudos_qodef_add_admin_row(array(
            'name' => 'typography_row2',
            'next' => true,
            'parent' => $typography_group
        ));		
		
        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row2,
            'type'          => 'selectsimple',
            'name'          => 'tabs_font_weight',
            'default_value' => '',
            'label'         => esc_html__('Font Weight', 'kudos'),
            'options'       => kudos_qodef_get_font_weight_array()
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row2,
            'type'          => 'textsimple',
            'name'          => 'tabs_font_size',
            'default_value' => '',
            'label'         => esc_html__('Font Size', 'kudos'),
            'args'          => array(
                'suffix' => 'px'
            )
        ));

        //DARK TABS SKIN
		
		//Initial Tab Color Styles
		
		kudos_qodef_add_admin_section_title(array(
            'name' => 'dark_tab_color_section_title',
            'title' => esc_html__('Dark Tab Navigation Color Styles', 'kudos'),
            'parent' => $panel
        ));
        $dark_tabs_color_group = kudos_qodef_add_admin_group(array(
            'name' => 'dark_tabs_color_group',
            'title' => esc_html__('Tab Navigation Color Styles', 'kudos'),
			'description' => esc_html__('Set color styles for tab navigation', 'kudos'),
            'parent' => $panel
        ));
		$dark_tabs_color_row = kudos_qodef_add_admin_row(array(
            'name' => 'dark_tabs_color_row',
            'next' => true,
            'parent' => $dark_tabs_color_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $dark_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'dark_tabs_color',
            'default_value' => '',
            'label'         => esc_html__('Color', 'kudos')
        ));
		kudos_qodef_add_admin_field(array(
            'parent'        => $dark_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'dark_tabs_back_color',
            'default_value' => '',
            'label'         => esc_html__('Background Color', 'kudos')
        ));
		
		//Active Tab Color Styles
		
		$active_dark_tabs_color_group = kudos_qodef_add_admin_group(array(
            'name' => 'active_dark_tabs_color_group',
            'title' => esc_html__('Active and Hover Navigation Color Styles', 'kudos'),
			'description' => esc_html__('Set color styles for active and hover tabs', 'kudos'),
            'parent' => $panel
        ));
		$active_dark_tabs_color_row = kudos_qodef_add_admin_row(array(
            'name' => 'active_dark_tabs_color_row',
            'next' => true,
            'parent' => $active_dark_tabs_color_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $active_dark_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'dark_tabs_color_active',
            'default_value' => '',
            'label'         => esc_html__('Color', 'kudos')
        ));
		kudos_qodef_add_admin_field(array(
            'parent'        => $active_dark_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'dark_tabs_back_color_active',
            'default_value' => '',
            'label'         => esc_html__('Background Color', 'kudos')
        ));

        //LIGHT TABS SKIN

        //Initial Tab Color Styles

        kudos_qodef_add_admin_section_title(array(
            'name' => 'light_tab_color_section_title',
            'title' => esc_html__('Light Tab Navigation Color Styles', 'kudos'),
            'parent' => $panel
        ));
        $light_tabs_color_group = kudos_qodef_add_admin_group(array(
            'name' => 'light_tabs_color_group',
            'title' => esc_html__('Tab Navigation Color Styles', 'kudos'),
            'description' => esc_html__('Set color styles for tab navigation', 'kudos'),
            'parent' => $panel
        ));
        $light_tabs_color_row = kudos_qodef_add_admin_row(array(
            'name' => 'light_tabs_color_row',
            'next' => true,
            'parent' => $light_tabs_color_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $light_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'light_tabs_color',
            'default_value' => '',
            'label'         => esc_html__('Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
            'parent'        => $light_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'light_tabs_back_color',
            'default_value' => '',
            'label'         => esc_html__('Background Color', 'kudos')
        ));

        //Active Tab Color Styles

        $active_light_tabs_color_group = kudos_qodef_add_admin_group(array(
            'name' => 'active_light_tabs_color_group',
            'title' => esc_html__('Active and Hover Navigation Color Styles', 'kudos'),
            'description' => esc_html__('Set color styles for active and hover tabs', 'kudos'),
            'parent' => $panel
        ));
        $active_light_tabs_color_row = kudos_qodef_add_admin_row(array(
            'name' => 'active_light_tabs_color_row',
            'next' => true,
            'parent' => $active_light_tabs_color_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $active_light_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'light_tabs_color_active',
            'default_value' => '',
            'label'         => esc_html__('Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
            'parent'        => $active_light_tabs_color_row,
            'type'          => 'colorsimple',
            'name'          => 'light_tabs_back_color_active',
            'default_value' => '',
            'label'         => esc_html__('Background Color', 'kudos')
        ));
        
    }

    add_action('kudos_qodef_options_elements_map', 'kudos_qodef_tabs_map');
}