<?php
namespace KudosQodef\Modules\Shortcodes\VerticalSplitSlider;

use KudosQodef\Modules\Shortcodes\Lib\ShortcodeInterface;

/**
 * Class Vertical Split Slider
 */
class VerticalSplitSlider implements ShortcodeInterface{
	private $base; 
	
	function __construct() {
		$this->base = 'qodef_vertical_split_slider';

		add_action('vc_before_init', array($this, 'vcMap'));
	}
	
	/**
		* Returns base for shortcode
		* @return string
	 */

	public function getBase() {
		return $this->base;
	}

	public function vcMap() {
		if(function_exists('vc_map')){
			vc_map(
				array(
					'name' => esc_html__('Select Vertical Split Slider', 'kudos'),
					'base' => $this->base,
					'category' => 'by SELECT',
					'icon' => 'icon-wpb-vertical-split-slider extended-custom-icon',
					'as_parent' => array('only' => 'qodef_vertical_split_slider_left_panel, qodef_vertical_split_slider_right_panel'),
					'js_view' => 'VcColumnView',
					'params' => array_merge(
						array(
							array(
								"type" => "textfield",
								"class" => "",
								"heading" => esc_html__("Left Slide Panel size (%)", 'kudos'),
								"param_name" => "left_slide_panel_size",
								"description" => ""
							),
							array(
								"type" => "textfield",
								"class" => "",
								"heading" => esc_html__("Right Slide Panel size (%)", 'kudos'),
								"param_name" => "right_slide_panel_size",
								"description" => ""
							),
							array(
								"type" => "dropdown",
								"class" => "",
								"heading" => esc_html__("Disable Dark/Light Header Skin Change", 'kudos'),
								"param_name" => "disable_header_skin_change",
								"value" => array(
									esc_html__("No", 'kudos') => "no",
									esc_html__("Yes", 'kudos') => "yes"
								),
								'save_always' => true,
								"description" => ""
							)
						)
					)
				)
			);
		}
	}

	public function render($atts, $content = null) {
		
		$args = array(
			'left_slide_panel_size' 	=> '',
			'right_slide_panel_size' 	=> '',
			'disable_header_skin_change'=> ''
        );

		$params = shortcode_atts($args, $atts);

        extract($params);

        $html = '';

        $vertical_split_slider_classes = array();

		$vertical_split_slider_classes[] = 'qodef-vertical-split-slider qodef-vertical-split-slider-holder';

		$vertical_split_slider_classes = implode(' ', $vertical_split_slider_classes);

        $html .= '<div '. kudos_qodef_get_class_attribute($vertical_split_slider_classes) . ' data-left-slide-panel-size="'.$params['left_slide_panel_size'].'" data-right-slide-panel-size="'.$params['right_slide_panel_size'].'" data-disable-header-skin-change="'.$params['disable_header_skin_change'].'">';
            $html .= do_shortcode($content);
        $html .= '</div>';

        return $html;

	}

}