<?php
/**
 * Product quantity inputs
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/global/quantity-input.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     2.5.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( $max_value && $min_value === $max_value ) {
	?>
	<div class="qodef-quantity-buttons quantity hidden">
		<input type="hidden" class="qty" name="<?php echo esc_attr( $input_name ); ?>" value="<?php echo esc_attr( $min_value ); ?>" />
	</div>
	<?php
} else {
	?>
	<div class="quantity qodef-quantity-buttons">
		<span class="qodef-quantity-plus  arrow_triangle-up"></span>
		<input type="text" step="<?php echo esc_attr($step); ?>" min="<?php echo esc_attr($min_value); ?>"
			max="<?php echo esc_attr($max_value); ?>" name="<?php echo esc_attr($input_name); ?>"
			value="<?php echo esc_attr($input_value); ?>"
			title="<?php echo esc_attr_x('Qty', 'Product quantity input tooltip', 'aton') ?>"
			class="input-text qty text qodef-quantity-input" size="4" pattern="<?php echo esc_attr($pattern); ?>"
			inputmode="<?php echo esc_attr($inputmode); ?>"/>
		<span class="qodef-quantity-minus  arrow_triangle-down"></span>
	</div>
	<?php
}